%% This is file `DEMO-TUDaBeamer.tex' version 2.09 (2020/03/13),
%% it is part of
%% TUDa-CI -- Corporate Design for TU Darmstadt
%% ----------------------------------------------------------------------------
%%
%%  Copyright (C) 2018--2020 by Marei Peischl <marei@peitex.de>
%%
%% ============================================================================
%% This work may be distributed and/or modified under the
%% conditions of the LaTeX Project Public License, either version 1.3c
%% of this license or (at your option) any later version.
%% The latest version of this license is in
%% http://www.latex-project.org/lppl.txt
%% and version 1.3c or later is part of all distributions of LaTeX
%% version 2008/05/04 or later.
%%
%% This work has the LPPL maintenance status `maintained'.
%%
%% The Current Maintainers of this work are
%%   Marei Peischl <tuda-ci@peitex.de>
%%   Markus Lazanowski <latex@ce.tu-darmstadt.de>
%%
%% The development respository can be found at
%% https://github.com/tudace/tuda_latex_templates
%% Please use the issue tracker for feedback!
%%
%% ============================================================================
%%
% !TeX program = lualatex
%%

\documentclass[
	ngerman,%globale Übergabe der Hauptsprache
	aspectratio=169,%Beamer eigene Option zum Umschalten des Formates
	color={accentcolor=2d},
	logo=false,%Kein Logo auf Folgeseiten
	colorframetitle=false,%Akzentfarbe auch im Frametitle
%	logofile=example-image, %Falls die Logo Dateien nicht vorliegen
	]{tudabeamer}
\usepackage[main=ngerman]{babel}
\usepackage{booktabs}
\usepackage{listings}
\usepackage{pgfgantt}
\usepackage{rotating}
\usepackage{multimedia}

% Der folgende Block ist nur bei pdfTeX auf Versionen vor April 2018 notwendig
\usepackage{iftex}
\ifPDFTeX
\usepackage[utf8]{inputenc}%kompatibilität mit TeX Versionen vor April 2018
\fi

 %Let's define some awesome new ganttchart elements:
\newganttchartelement{orangebar}{
    orangebar/.style={
        inner sep=0pt,
        draw=red!66!black,
        very thick,
        top color=white,
        bottom color=orange!80
    },
    orangebar label font=\slshape,
    orangebar left shift=.1,
    orangebar right shift=-.1
}

\newganttchartelement{bluebar}{
    bluebar/.style={
        inner sep=0pt,
        draw=purple!44!black,
        very thick,
        top color=white,
        bottom color=blue!80
    },
    bluebar label font=\slshape,
    bluebar left shift=.1,
    bluebar right shift=-.1
}

\newganttchartelement{greenbar}{
    greenbar/.style={
        inner sep=0pt,
        draw=green!50!black,
        very thick,
        top color=white,
        bottom color=green!80
    },
    greenbar label font=\slshape,
    greenbar left shift=.1,
    greenbar right shift=-.1
}

\newganttchartelement{graybar}{
    graybar/.style={
        inner sep=0pt,
        draw=gray!50!black,
        very thick,
        top color=white,
        bottom color=gray!80
    },
   graybar label font=\slshape,
   graybar left shift=.1,
   graybar right shift=-.1
}

\newganttchartelement{yellowbar}{
    yellowbar/.style={
        inner sep=0pt,
        draw=white,
        thick,
        top color=white,
        bottom color=white
    },
   yellowbar label font=\slshape,
   yellowbar left shift=.1,
   yellowbar right shift=-.1
}


\input{../solidity-highlighting}


%Makros für Formatierungen der Doku
%Im Allgemeinen nicht notwendig!
\let\code\texttt
\title{Blockchain Praktikum 2020
by Prof. Dr. Sebastian Faust}
\subtitle{ Integrating IoT in a Decentralized Renting Application}
\author[Alexander Lieb, Lennard Rüdesheim]{Alexander Lieb, Lennard Rüdesheim}
\department{FB 20}
\institute{Angewandte Kryptographie}

%Fremdlogo
%Logo Macro mit Sternchen skaliert automatisch, sodass das Logo in die Fußzeile passt
\logo*{\includegraphics{CAC-Logo-RGB_182_1}}

% Da das Bild frei wählbar nach Breite und/oder Höhe skaliert werden kann, werden \width/\height entsprechend gesetzt. So kann die Fläche optimal gefüllt werden.
%Sternchenversion skaliert automatisch und beschneidet das Bild, um die Fläche zu füllen.
%\titlegraphic*{\includegraphics{example-image}}
\date{\today}

\begin{document}

\maketitle

\setupTUDaFrame{logo=true}
\begin{frame}{Motivation}
  \begin{minipage}{\linewidth}
    \begin{figure}
      \includegraphics[scale=0.1]{img/uber.jpg}
    \end{figure}
  \end{minipage}
  \begin{minipage}{0.49\linewidth}
    \begin{figure}
      \includegraphics[scale=0.4]{img/blablacar.jpg}
    \end{figure}
  \end{minipage}%
  \begin{minipage}{0.49\linewidth}
    \begin{figure}
      \includegraphics[scale=0.2]{img/airbnb.jpg}
    \end{figure}
  \end{minipage}
  
\end{frame}

\begin{frame}{Motivation (2)}
  What's the problem with these traditional approaches?
  \vspace{0.5cm}
  \begin{itemize}
  \item Provider controls the access
  \vspace{0.5cm}
  \item Provider reveals your privacy
  \vspace{0.5cm}
  \item Provider demands fees
  \end{itemize}
  \vspace{0.5cm}
  What can be done?
\end{frame}

\begin{frame}{Motivation (3)}
  Build a decentralized application\\
  \vspace{0.5cm}
  Owner of products should be able to add or remove their products\\
  \vspace{0.5cm}
  Hirer should be able to rent or return a product\\
  \vspace{0.5cm}
  \begin{center}
  \textbf{
  Free access and no fees are targeted using this approach\\
  \vspace{0.5cm}
  But what about privacy?}
  \end{center}
\end{frame}

\begin{frame}{Motivation (4)}
  What if owner and hirer never met?\\
  \vspace{0.5cm}
  If the only information everyone gets, is a public key?\\
  \vspace{0.5cm}
  If the smart contract automatically controls the hirer?\\
  \vspace{0.5cm}
  And the only way, the owner recognizes that the product was rented, is that he got some money?\\
  \vspace{0.5cm}
  How can you achieve this?\\
  \vspace{0.5cm}
  And isn't ubiquitous computing exactly meant for something like this?
\end{frame}


\begin{frame}{Integrating IoT in a Decentralized Renting Application\\
  An example showcase for sharing your bike}

  \begin{figure}
    \centering
    \includegraphics[scale=.45]{img/recap.jpg}
  \end{figure}
    
\end{frame}

\begin{frame}{Background}
  \begin{itemize}
  \item Several decentralized renting systems are already implemented
  \end{itemize}

  \begin{columns}
    \begin{column}{0.48\textwidth}
        \begin{block}{Bogner et al.}
          \begin{itemize}
          \item Android App
          \item for each product the owner posts a contract
          \item customer scans the QR code to find the contract
          \end{itemize}
        \end{block}
    \end{column}
    \begin{column}{0.48\textwidth}
      \begin{block}{Niya et al.}
        \begin{itemize}
        \item Android App
        \item Each user has to register with real data
        \item legally valid contracts
        \item transaction cost calculation 
        \end{itemize}
\vspace{0.31cm}
      \end{block}
    \end{column}
\end{columns}
  \vspace{0.3cm}
  \begin{center}
  \item $\Rightarrow $ but none of them uses the IoT functionality
  \end{center}
\end{frame}

\begin{frame}{Architecture}

  The architecture of our solution consists of three basic parts.\\
  \vspace{0.5cm}
  \begin{itemize}
  \item The DAPP\\
  \vspace{0.5cm}
  \item The setup of the IoT
  \vspace{0.5cm}
  \item The connection between the DAPP and the IoT
  \end{itemize}
   
\end{frame}


\begin{frame} {The DAPP}
  \begin{minipage}{0.29\textwidth}
    Two contracts
    \begin{itemize}
    \item Master Contract
    \item City Contract
    \end{itemize}
  \end{minipage}%
  \begin{minipage}{0.69\textwidth}
  \begin{figure}
    \centering
    \includegraphics[scale=.4]{img/contracts.jpg}
  \end{figure}
  \end{minipage}
  Basic Functionality of the City Contract
  \begin{itemize}
  \item Add a bike
  \item Remove a bike
  \item Rent a bike
  \item Return a bike
  \end{itemize}
\end{frame}

\begin{frame}{Add and Remove Bike Protocol}

  \begin{minipage}{0.49\linewidth}
    \begin{figure}
      \centering
      \includegraphics[scale=0.5]{img/adding_bike_protocol.pdf}
    \end{figure}
  \end{minipage}%
  \begin{minipage}{0.49\linewidth}
    \begin{figure}
      \centering
      \includegraphics[scale=0.5]{img/removing_bike_protocol.pdf}
    \end{figure}
  \end{minipage}
\end{frame}


\begin{frame} {User Interface}
  \begin{minipage}{0.49\linewidth}
  \begin{figure}
    \centering
    \includegraphics[scale=.3]{img/Screenshot_City_UI_Bikes.png}
  \end{figure}
  \end{minipage}%
  \begin{minipage}{0.49\linewidth}
  \begin{figure}
    \centering
    \includegraphics[scale=.3]{img/Screenshot_City_UI_Forms.png}
  \end{figure}
  \end{minipage}
\end{frame}

\begin{frame} {User Interface}
  \begin{figure}
    \centering
    \includegraphics[scale=.28]{img/Screenshot_Map.png}
  \end{figure}  
\end{frame}

\begin{frame}{Setup of the IoT device\\Building the bike lock}

  \begin{minipage}{0.49\linewidth}
    \begin{figure}
      \includegraphics[scale=0.04]{img/IMG_9720.jpg}
    \end{figure}
  \end{minipage}%
  \begin{minipage}{0.49\linewidth}
    \begin{figure}
      \includegraphics[scale=0.04]{img/IMG_9721.jpg}
    \end{figure}
  \end{minipage}%
  
\end{frame}

\begin{frame}{Setup of the IoT device (2)\\Building the bike lock}

  \begin{minipage}{0.49\linewidth}
    \begin{figure}
      \includegraphics[scale=0.02]{img/first.JPG}
    \end{figure}
    \begin{figure}
      \includegraphics[scale=0.02]{img/third.JPG}
    \end{figure}
  \end{minipage}%
  \begin{minipage}{0.49\linewidth}
    \begin{figure}
      \includegraphics[scale=.02]{img/second.JPG}
    \end{figure}
    \begin{figure}
      \includegraphics[scale=.02]{img/fourth.JPG}
    \end{figure}
  \end{minipage}%

\end{frame}

\begin{frame}{Setup of the IoT device (3)}
    \begin{figure}
      \includegraphics[scale=.055]{img/IMG_9730.JPG}
    \end{figure}
\end{frame}

\begin{frame}{Setup of the IoT device (4)}

  The software is written in Python, using \\
  \vspace{.5cm}
  \begin{itemize}
  \item web3.py
    \vspace{.5cm}
  \item geopy
  \end{itemize}
  \begin{figure}
    \includegraphics[scale=.1]{img/python.png}
  \end{figure}
  Interested? Fork me on gitlab:  \href{https://git.rwth-aachen.de/a.lieb/bc-praktikum-group2}{https://git.rwth-aachen.de/a.lieb/bc-praktikum-group2}
\end{frame}

\begin{frame}{Connection between DAPP and IoT}

  We are still missing three protocols:
  \vspace{.5cm}
  \begin{enumerate}
  \item Setup of the connection between IoT device and SC
    \vspace{.5cm}
  \item Rent bike protocol
    \vspace{.5cm}
  \item Return bike protocol
  \end{enumerate}
    
\end{frame}

\begin{frame}{Connection between DAPP and IoT (2)}
  \begin{figure}
    \centering
    \includegraphics[scale=0.4]{img/IoT_contract_connection_protocol}
  \end{figure}
  
\end{frame}


\begin{frame}{Rent Bike Protocol}
  \begin{figure}
    \centering
    \includegraphics[scale=0.35]{img/rent_bike_protocol.pdf}
  \end{figure}
\end{frame}

\begin{frame}{Return Bike Protocol}
  \begin{figure}
    \centering
    \includegraphics[scale=0.5]{img/return_bike_protocol.pdf}
  \end{figure}
\end{frame}

\begin{frame}{Attacks}

  We identified three kinds of attacks
  \vspace{0.5cm}
  \begin{enumerate}
  \item Physical Attacks
    \vspace{0.5cm}
  \item Attacks against the IoT device
    \vspace{0.5cm}
  \item Attacks against the Smart Contracts
  \end{enumerate}
    
\end{frame}

\begin{frame}{Physical Attacks (shortly)}
  The location of the bike is easily accessable\\
  \vspace{.5cm}
  Attacker can break the lock or the bike $\rightarrow$ place lock in secure case\\
  \vspace{.5cm}
  Attacker can reboot the device $\rightarrow$ boot of the device should not cost any gas\\
  \vspace{.5cm}
  GPS jamming $\rightarrow$ lost signal $\rightarrow$ Effect depends on state: DoS, or no cost per km, or nothing\\
  \vspace{.5cm}
  No internet connection $\rightarrow$ Need for another feature (Bluetooth)
\end{frame}

\begin{frame}{Attacks against the IoT device (shortly)}
  \vspace{.5cm}
  Device is off $\rightarrow$ Attacker may try to get image of memory $\rightarrow$ Secure Storage (OP-TEE)\\
  \vspace{.5cm}
  Device is on $\rightarrow$ switch off all possible shells $\rightarrow$ Check input from the outside world
\end{frame}

\begin{frame}{Attacks against Smart Contracts}

  Two main attack vectors
  \vspace{.5cm}
  \begin{enumerate}
  \item Hirer does not return bike
  \item Owner places fake bikes
  \end{enumerate}
  
\end{frame}

\begin{frame}{Hirer does not return bike}

  When the hirer does not return the bike, the fund is kept. This should be more expensive than buying a bike.

  \begin{center}
  \textbf{But who gets the money?\\Let's imagine, we transfer it to the bike owner}
  \end{center}
\end{frame}

\begin{frame}{Fake Bikes}
  Let's imagine Eve buys a new bike lock. She gets a pk for it and registers it at a city contract. \\
  \vspace{.2cm}
  Now she creates a new public key pk2 and registers it at the city contract as a bike\\
  \vspace{.2cm}
  Eve writes pk2 on the bike lock.\\
  \vspace{.2cm}
  Bob sees Eves bike in the city. He likes it and requests \textbf{pk2}.\\
  \vspace{.2cm}
  Since this is not the real public key of the bike lock, the lock does not open\\
  \vspace{.2cm}
  \textbf{But Bobs refund is gone}
\end{frame}

\begin{frame}{Fake Bikes (2)}
  So what to do?\\
  \vspace{.5cm}
  Bobs refund stays in the contract forever \\
  \vspace{.5cm}
  Eve placed refund for creating the bike, this is lost too.
\end{frame}

\begin{frame}
  \vspace{3cm}
  \centering
  \textbf{Thanks for listening} \\
  \textbf{Questions?}
\end{frame}

\end{document}

